/*
* Copyright 2008 Federal Chancellery Austria and
* Graz University of Technology
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
package at.gv.egiz.bku.gui.viewer;

import java.io.File;
import java.util.ResourceBundle;
import javax.swing.filechooser.FileFilter;

/**
 *
 * @author clemens
 */
class MimeFilter extends FileFilter {

  protected String mimeType;
  protected ResourceBundle messages;

  public MimeFilter(String mimeType, ResourceBundle messages) {
    this.mimeType = mimeType;
    this.messages = messages;
  }

  @Override
  public boolean accept(File f) {

    if (f.isDirectory()) {
      return true;
    }
    return MimeTypes.getExtension(mimeType).equalsIgnoreCase(getExtension(f));
  }

  private String getExtension(File f) {
    String ext = null;
    String s = f.getName();
    int i = s.lastIndexOf('.');

    if (i > 0 && i < s.length() - 1) {
      ext = s.substring(i + 1).toLowerCase();
    }
    return ext;
  }

  @Override
  public String getDescription() {
    return messages.getString(MimeTypes.getDescriptionKey(mimeType));
  }

  public static String getExtension(String mimeType) {
    return MimeTypes.getExtension(mimeType);
  }
}